/*************************************************
* OnLineEditor
* Author      : TengQiu Li
* E-Mail      : litqqs@163.com
* Copyright   : TengQiu Li
* Version     : 1.3.0 rc3
* Site        : http://www.e512.net
*************************************************/
var ua = navigator.userAgent.toLowerCase();
var isIE =!!window.ActiveXObject; //ie  // ua.indexOf('trident')>=0 || ua.indexOf('msie 6')>=0 ; 
var isIE6 = isIE && !window.XMLHttpRequest;//ie6
var isIE9 = !!document.createDocumentFragment;
var isWebkit = ua.indexOf('webkit')>=0; //chrome,safari
var isOpera = ua.indexOf('presto')>=0; //opera
var isGecko = ua.indexOf('gecko')>=0; //firefox

function tqEditor(objId,userConfig)
{
	var $=this;
	$.objId = objId;
	var config={
		"paragraphs" : [
			["段落",	"p"],
			["标题1",	"h1"],
			["标题2",	"h2"],
			["标题3",	"h3"],
			["标题4",	"h4"],
			["标题5",	"h5"],
			["标题6",	"h6"],
			["预定义",	"pre"]
			],
		"fontnames" : [
			["宋体",            "宋体"],
			["新宋体",          "新宋体"],
			["仿宋_GB2312",     "仿宋_GB2312"],
			["黑体",            "黑体"],
			["微软雅黑",        "微软雅黑"],
			["楷体_GB2312",     "楷体_GB2312"],
			["Arial",           "arial, helvetica, sans-serif"],
			["Courier New",     "courier new, courier, mono"],
			["Georgia",         "Georgia, Times New Roman, Times, Serif"],
			["Tahoma",          "Tahoma, Arial, Helvetica, sans-serif"],
			["Times New Roman", "times new roman, times, serif"]
			],
		"fontsizes": [
			//[text,preview,	value]
			["特小","xx-small",	1],
			["较小","x-small",	2],
			["小",	"small",	3],
			["中",	"medium",	4],
			["大",	"large",	5],
			["较大","x-large",	6],
			["特大","xx-large",	7]
			],
		"toolbar":'default',
		"toolbarRight":[],
		'showToolbarGroupHandle':true, //显示工具组最前的图
		
		//模板
		//插入媒体***时的模板代码,
		//flash	宏 {$url} {$width} {$height}
		'tplFlash':'<object classid="clsid:D27CDB6E-AE6D-11cf-96B8-444553540000" codebase="http://download.macromedia.com/pub/shockwave/cabs/flash/swflash.cab#version=7,0,19,0" width="{$width}" height="{$height}"><param name="movie" value="{$url}" /><param name="quality" value="high" /><param name="wmode" value="transparent" /><param name="allowScriptAccess" value="always" /><embed src="{$url}" width="{$width}" height="{$height}" quality="high" pluginspage="http://www.macromedia.com/go/getflashplayer" type="application/x-shockwave-flash" wmode="transparent" allowscriptaccess="always"></embed></object>',
		//flv视频 宏 {$url} {$width} {$height} {$auto_start}
		'tplFlv':'<object classid="clsid:d27cdb6e-ae6d-11cf-96b8-444553540000" codebase="http://download.macromedia.com/pub/shockwave/cabs/flash/swflash.cab#version=9,0,0,0" name="play" width="{$width}" height="{$height}" align="middle" id="play"><param name="allowScriptAccess" value="sameDomain" /><param name="allowFullScreen" value="false" /><param name="movie" value="'+tqEditor.url+'flvPlayer.swf" /><param name="quality" value="high" /><param name="bgcolor" value="#0E0E0E" /><param name="FlashVars" value="vcastr_file={$url}" /><param name="wmode" value="opaque" /><embed src="'+tqEditor.url+'flvPlayer.swf" flashvars="vcastr_file={$url}" quality="high" bgcolor="#0E0E0E" width="{$width}" height="{$height}" name="play" align="middle" allowscriptaccess="sameDomain" allowfullscreen="false" type="application/x-shockwave-flash" pluginspage="http://www.macromedia.com/go/getflashplayer" wmode="opaque" /></object>',
		//rm视频 宏 {$url} {$width} {$height} {$auto_start}
		'tplRm':'<object id="video2" classid="clsid:CFCDAA03-8BE4-11cf-B84B-0020AFBBCCFA" width={$width} height={$height}>  <param name="_ExtentX" value="11906">  <param name="_ExtentY" value="8996">  <param name="AUTOSTART" value="{$auto_start}">  <param name="SHUFFLE" value="0">  <param name="PREFETCH" value="0">  <param name="NOLABELS" value="0">  <param name="SRC" value="{$url}">  <param name="CONTROLS" value="ImageWindow">  <param name="CONSOLE" value="Clip1">  <param name="LOOP" value="0">  <param name="NUMLOOP" value="0">  <param name="CENTER" value="0">  <param name="MAINTAINASPECT" value="0">  <param name="BACKGROUNDCOLOR" value="#000000">  <embed src="4.rpm" type="audio/x-pn-realaudio-plugin" console="Clip1" controls="ImageWindow" width={$width} height={$height} autostart="{$auto_start}"></embed></object>',
		//windows的媒体文件 宏 {$url} {$width} {$height} {$auto_start}
		'tplVideo':'<object id="wmp"  classid="clsid:6BF52A52-394A-11d3-B153-00C04F79FAA6"  type="application/x-ms-wmp" width="{$width}" height="{$height}"><param name="URL" value="{$url}" /><param name="autoStart" value="{$auto_start}" /><param name="invokeURLs" value="false"><param name="playCount" value="100"><param name="Volume" value="100"><param name="defaultFrame" value="datawindow"></object>',
		//音乐播放 宏 {$url} {$auto_start} 
		'tplMusic':'<object id="wmp"  classid="clsid:6BF52A52-394A-11d3-B153-00C04F79FAA6"  type="application/x-ms-wmp" width="230" height="64"><param name="URL" value="{$url}" /><param name="autoStart" value="{$auto_start}" /><param name="invokeURLs" value="false"><param name="playCount" value="100"><param name="Volume" value="100"><param name="defaultFrame" value="datawindow"></object>',
		//分页符代码
		'tplSplitPage':'<h3 class="splitPage" name="split_page" ></h3>',

		'uploadFieldName':'file',//接收上传时的上传表单名

		'imageUploadUrl':'',//接收上传图片网址, 留空表示不允许上传, 以#开头, 表示点击上传按扭后的界面网址
		'imageFileTypes':'*.jpg;*.gif;*.png;*.jpeg',//允许上传的图片后缀
		'imageFileSize':'2MB',//允许上传文件大小
		'directInsertUploadImage':true,//直接将上传的图片插入编辑器中
		
		'linkUploadUrl':'',//接收上传网址, 留空表示不允许上传, 以#开头, 表示点击上传按扭后的界面网址
		'linkFileTypes':'*.*',//允许上传的后缀
		'linkFileSize':'2MB',//允许上传文件大小

		'flvUploadUrl':'',//接收上传Flv网址, 留空表示不允许上传, 以#开头, 表示点击上传按扭后的界面网址
		'flvFileTypes':'*.flv',//允许上传的文件后缀
		'flvFileSize':'2MB',//允许上传文件大小
		
		'flashUploadUrl':'',//接收上传Flash网址, 留空表示不允许上传, 以#开头, 表示点击上传按扭后的界面网址
		'flashFileTypes':'*.swf',//允许上传的图片后缀
		'flashFileSize':'2MB',//允许上传文件大小
		
		'musicUploadUrl':'',//接收上传音频文件网址, 留空表示不允许上传, 以#开头, 表示点击上传按扭后的界面网址
		'musicFileTypes':'*.mp3;*.wma',//允许上传音频文件后缀
		'musicFileSize':'2MB',//允许上传文件大小

		'videoUploadUrl':'',//接收上传window视频文件网址, 留空表示不允许上传, 以#开头, 表示点击上传按扭后的界面网址
		'videoFileTypes':'*.mkv;*.wmv;*.asf;*.avi',//允许上传window视频文件后缀
		'videoFileSize':'2MB',//允许上传文件大小
		
		'rmUploadUrl':'',//接收上传RM格式文件网址, 留空表示不允许上传, 以#开头, 表示点击上传按扭后的界面网址
		'rmFileTypes':'*.rmvb;*.rm',//允许上传RM格式文件后缀
		'rmFileSize':'2MB',//允许上传文件大小

		'enter2br':false,
		'formatHTML':true,//对HTML源码进行美化(换行与缩进)
		//'height_delta':20,
		'width':'auto',
		'height':'auto',
		'css':'',//设计辅助的相关样式网址
		'autoClean':true,//在执行粘贴时,自动清理word相关的垃圾代码
		'faceCount':55,//表情数量, 在face目录中
		'bgColor':'',  //可视化编辑时, 编辑器背景色
		'textColor':'',	//可视化编辑时, 文字色
		'debug':false
	};
	if(userConfig){
		for(var k in userConfig){
			config[k] = userConfig[k];
		}
	};

	if(typeof config.toolbar =='string'){
		switch(config.toolbar){
			case 'admin' : config.toolbar =  ['paragraph','fontsize','|','bold','italic','underline','forecolor','backcolor','removeformat','moreformat','|','justifyleft','justifycenter','justifyright',
				'||','createlink','insertimage','inserttable','splitpage','|','insertflash','insertflv',
				'||','cleanword','typeset'];
				if(config.toolbarRight.length<1)config.toolbarRight=['incheight','decheight','fullscreen','mode','|','help'];
			break;
			case 'user' : config.toolbar =  ['fontsize','|','bold','italic','underline','forecolor','backcolor','removeformat','moreformat','|','justifyleft','justifycenter','justifyright',
				'||','createlink','insertimage','inserttable','|','insertmusic','insertflv'];
				if(config.toolbarRight.length<1)config.toolbarRight=['incheight','decheight','fullscreen','mode'];
			break;
			case 'mini' : config.toolbar = ['fontsize','|','bold','italic','underline','forecolor','backcolor','removeformat','|','align','|','createlink','insertimage'];
			break;
			case 'message' : config.toolbar = ['insertface','|','fontsize','|','bold','italic','underline','|','forecolor','backcolor','|','removeformat'];
			break;
			case 'full' : config.toolbar =  ['paragraph','fontname','fontsize','|','bold','italic','underline','forecolor','backcolor','removeformat',
				'||','align','list','iodent','|','superscript','subscript',
				'||','createlink','unlink','insertimage','inserttable','inserthorizontalrule','splitpage','insertface','|','insertmusic','insertflash','insertflv','insertvideo','insertrm',
				'||','cleanword','typeset'];
				if(config.toolbarRight.length<1)config.toolbarRight=['incheight','decheight','fullscreen','mode','|','help'];
			break;
			case 'default':
			default : config.toolbar =  ['paragraph','fontsize','|','bold','italic','underline','forecolor','backcolor','removeformat',
				'||','align','list','iodent',
				'||','createlink','insertimage','inserttable','|','insertflv','insertface'];
				if(config.toolbarRight.length<1)config.toolbarRight=['fullscreen','mode','|','help'];
		}
	};

	$.config = config;

	//
	$.buttonList={
		//name :			[cmd,					title,			bg-left,	width]
		"paragraph":		['Paragraph',			'段落',			935,		20],
		"fontname":			['FontName',			'字体',			59,			20],
		"fontsize":			['FontSize',			'文字大小',		81,			20],
		
		"forecolor":		['ForeColor',			'文本颜色',		240,		20],
		"backcolor":		['BackColor',			'背景色',		260,		20],
		'bold':				['Bold',				'粗体',			0,			20],
		'italic':			['Italic',				'斜体',			20,			20],
		'underline':		['Underline',			'下划线',		39,			20],
		'strikethrough':	['Strikethrough',		'删除线',		722,		20],
		'removeformat':		['RemoveFormat',		'消除格式',		700,		20],
		'moreformat':		['MoreFormat',			'',				957,		10],

		"subscript":		['SubScript',			'下标',			762,		20],
		"superscript":		['SuperScript',			'上标',			742,		20],

		"align":			['Align',				'对齐',			425,		22],
		"justifyleft":		['JustifyLeft',			'左对齐',		101,		20],
		"justifycenter":	['JustifyCenter',		'居中对齐',		121,		20],
		"justifyright":		['JustifyRight',		'右对齐',		141,		20],
		//"justifyfull":		['JustifyFull',			'两端对齐',		0,		20],

		"list":				['List',				'列表',			447,		22],
		"unorderedlist":	['InsertUnorderedList',	'项目列表',		181,		20],
		"orderedlist":		['InsertOrderedList',	'数目列表',		161,		20],

		"iodent":			['Iodent',				'缩进方向',		469,		22],
		"outdent":			['Outdent',				'减少缩进',		201,		20],
		"indent":			['Indent',				'增加缩进',		221,		20],
		"inserthorizontalrule":['InsertHorizontalRule','插入水平线',821,		20],

		"createlink":		['CreateLink',			'添加链接',		285,		20],
		"unlink":			['UnLink',				'删除链接',		842,		20],
		"inserttable":		['InsertTable',			'插入表格',		591,		20],

		"insertimage":		['InsertImage',			'插入图片',		322,		20],
		"insertface":		['InsertFace',			'表情',			362,		20],

		"insertmusic":		['InsertMusic',			'插入音乐',		491,		20],
		"insertflash":		['InsertFlash',			'插入Flash',	530,		20],
		"insertflv":		['InsertFlv',			'插入flv',		571,		20],
		"insertrm":			['InsertRm',			'插入rm',		1009,		20],
		"insertvideo":		['InsertVideo',			'插入视频',		1029,		20],

		"cleanword":		['CleanWord',			'清理Word代码',	611,		20],
		"typeset":			['Typeset',				'自动排版',		1170,		20],
		"mode":				['Mode',				'查看源码',		631,		20],
		'splitpage':		['SplitPage',			'插入分页符',	652,		20],
		
		'group':			['group',				'',				309,		7,],
		'separator':		['separator',			'',				315,		5,],

		"incheight":		['IncHeight',			'增加高度',		781,		20],
		"decheight":		['DecHeight',			'减少高度',		801,		20],
		"fullscreen":		['FullScreen',			'全屏',			968,		20],

		'help':				['Help',				'帮助',			912,		20]
	};

	$._inited=false;
	$._containerDiv=null;
	$._toolbarDiv=null;
	$._clientDiv=null;
	//Methods
	$.init=function(){
		if($._inited) return;
		$.obj = $.find(objId);
		if($.obj.editor) return;//已执行过
		$.obj.editor = $;

		if (!$.config.width || $.config.width == "auto") {
			if($.obj.style.width){$.config.width = $.obj.style.width; }
			else if($.obj.cols){ $.config.width = ($.obj.cols * 8)+'px'; }
			else{ $.config.width = '100%'; }
		}
		if (!$.config.height || config.height == "auto") {
			if($.obj.style.height){ $.config.height = $.obj.style.height; }
			else if($.obj.rows){ $.config.height = ($.obj.rows * 17)+'px' }
			else{ $.config.height = '200'; }
		}

		//toolbar
		var code ='<div class="eToolBar" id="'+$.objId+'_EditorToolBar">';
		//
		if($.config.toolbarRight.length){
			code +='<ul class="eToolBarGroupRight" >';
			for(var i=0; i < $.config.toolbarRight.length; i++){
				code += $._btnCode($.config.toolbarRight[i], false);
			}
			code +='</ul>';
		}
		//工具组
		code +='<ul class="eToolBarGroup" >';
		if($.config.showToolbarGroupHandle){
			bn = $.buttonList['group'];
			code +='<div class="eButton"  style="background-position: -'+bn[2]+'px 0;width:'+bn[3]+'px;'+bn[4]+'" ></div>';
		}
		for(var i=0; i < $.config.toolbar.length; i++){
			code += $._btnCode($.config.toolbar[i], true);
		}
		code +='</ul>';
		//工具组完
		code +='</div>';
		//编辑区
		code +='<div id="'+$.objId+'_EditorClient">';
		code +='<iframe class="eEditorClient" id="'+$.objId+'_Editor" style="height:'+$.config.height+';" frameborder=0 ></iframe>';
		code +='</div>';

		if (!$.config.debug) {
			$.obj.style.display = "none";
		}
		var e =$.CE('DIV');
		e.id=	$.objId+'_EditorContainer';
		e.className='eEditor';
		e.style.width=$.config.width;
		e.innerHTML=code;
		$.obj.parentNode.insertBefore(e, $.obj);

		$._containerDiv = e;
		$._toolbarDiv = $.find($.objId+'_EditorToolBar');
		$._clientDiv = $.find($.objId+'_EditorClient');

		$._noSel($._toolbarDiv);
		//$._noSel($._toolbarDiv,'DIV,UL,LI');

		var btns = $._children($._toolbarDiv,'LI');
		for(var i=btns.length-1;i>=0;i--){
			$._ieMouseStyle(btns[i],'eButton','eButtonUp','eButtonDown');	//ie6

			$.addListener(btns[i],'click',	$._toolbarBottonClick);
			$.addListener(btns[i],'mouseout',	function(){
					var o=tqEditor.activePop;
					this.className=	(o && o.relateObj==this)? 'eButtonDropDown':'eButton';
					});
		}
		if(isIE){//IE6或IE8兼容模式时需要
			var groups = $._children($._toolbarDiv,'UL');
			for(var i=groups.length-1;i>=0;i--){
				var w=3;
				var btns=groups[i].childNodes;
				for(var j=btns.length-1;j>=0;j--){w += btns[j].offsetWidth+2;}
				groups[i].style.width=w+'px';
			}
		}
		//--
		$.setContent($.obj.value);
		$._changed();
		$.obj.focus = function(){this.editor.focus();}
		$._inited=true;
	};
	$._btnCode=function(tn, groupFlag){
		if('||'===tn) tn='group';
		else if('|'===tn) tn='separator';
		var bn = $.buttonList[tn];
		if(!bn) return '';
		var styleCode=function(bn){return 'class="eButton" style="background-position: -'+bn[2]+'px 0;width:'+bn[3]+'px;'+bn[4]+'"'; };
		switch(tn){
			case 'group':
				if(!groupFlag) return '';
				var code='</ul><ul class="eToolBarGroup" >';
				if($.config.showToolbarGroupHandle){
					code+= '<div '+styleCode(bn)+' ></div>';
				}
				return code;
			case 'separator':
				return '<div '+styleCode(bn)+' ></div>';
			default:
				return'<li id="'+$.objId+'_'+bn[0]+'" name="'+bn[0]+'" title="'+bn[1]+'" '+styleCode(bn)+' ></li>';
		}
	};
	$._children=function(domNode, tagName){
		return domNode.getElementsByTagName(tagName); 
	};
	//ie6
	$._ieMouseStyle=function(obj,normal,hover,down){
		if(!isIE || !isIE6 && document.compatMode == "CSS1Compat") return;
		$.addListener(obj,'mouseover',	function(){this.className=hover;});
		$.addListener(obj,'mouseup',	function(){this.className=hover;});
		$.addListener(obj,'mousedown',	function(){this.className=down;});
		$.addListener(obj,'mouseout',	function(){this.className=normal;});
	};
	$._keepBookmark=function(){
		if(isIE){
			var _bookmark;
			var win = $.find($.objId+'_Editor');
			$.addListener(win,'beforedeactivate',function(){_bookmark=$._getRange();});
			$.addListener(win,'activate',function(){
				if(null==_bookmark) return;
				var sel=$._getSelection();
				if(sel.addRange) sel.addRange(_bookmark);
				else _bookmark.select();
				_bookmark=null;
			});
		}
		$._hook();
	};
	$._noSel=function(o, tagsName){
		var noSel=function(){
			if(isIE){
				var tn=event.srcElement.tagName;
				return 'INPUT'==tn || 'TEXTAREA'==tn;
			}
			return false;
		};
		if(tagsName){
			var a=tagsName.split(',');
			for(var j=a.length-1;j>=0;j--){
				var nodes = $._children(o,a[j]);
				for(var i=nodes.length-1; i>=0;i--){
					nodes[i].unselectable='on';
					nodes[i].onselectstart = noSel
				}
			}
		}else{
			o.unselectable='on';
			o.onselectstart = noSel;
		}
	};
	$.listenTagEvent=function(node,tag,eventname,func){
		var ds = $._children(node,tag);
		for(var i=ds.length-1;i>=0;i--){
			$.addListener(ds[i],eventname,func);
		}
	};
	$._toolbarBottonClick=function(){
		var e=isIE ? event : arguments[0];
		e.cancelBubble = true;
		var cmd = this.getAttribute('name');
		$.focus();
		switch(cmd){
			case 'Paragraph':	return $._showParagraphUI(this); 
			case 'FontSize':	return $._showFontSizeUI(this); 
			case 'FontName':	return $._showFontNamesUI(this); 
			case 'Align':		return $._showButtonAsMenuUI(this,['justifyleft','justifycenter','justifyright']);
			case 'List':		return $._showButtonAsMenuUI(this,['orderedlist','unorderedlist']); 
			case 'Iodent':		return $._showButtonAsMenuUI(this,['indent','outdent']); 
			case 'ForeColor':	return $._showColorSelectUI(this,cmd); 
			case 'BackColor':	return $._showColorSelectUI(this, isIE ? 'BackColor':'HiliteColor');
			case 'MoreFormat':	return $._showButtonAsMenuUI(this,['orderedlist','unorderedlist','|','indent','outdent','|','superscript','subscript']);
			case 'CreateLink':	return $._showCreateLinkUI(this);
			case 'InsertImage':	return $._showInsertImageUI(this);
			case 'InsertTable':	return $._showInsertTableUI(this);
			case 'InsertFace':	return $._showInsertFacetUI(this);
			case 'InsertMusic':	return $._showInsertMusicUI(this);
			case 'InsertFlash':	return $._showInsertFlashUI(this);
			case 'InsertFlv':	return $._showInsertFlvUI(this);
			case 'InsertRm':	return $._showInsertRmUI(this);
			case 'InsertVideo':	return $._showInsertVideoUI(this);
			case 'CleanWord':	$.hidePop(); return $.cleanWord(true);
			case 'Typeset':		$.hidePop(); return $.typeset();
			case 'Mode':		$.hidePop(); return $.changeMode();
			case 'SplitPage':	$.hidePop(); return $.insertHtml($.config.tplSplitPage,'after');
			case 'IncHeight':	$.hidePop(); return $.changeHeight(100);
			case 'DecHeight':	$.hidePop(); return $.changeHeight(-100);
			case 'FullScreen':	$.hidePop(); return $.fullScreen();
			case 'Help':		return $._showHelpUI(this);
			default:			$.hidePop();return $.exeCmd(cmd);
		}
	};
	$.__selectOption=function(selectObj,value){
		for(var i=selectObj.options.length-1;i>=0;i--){
			if(selectObj.options[i].value==value){
				selectObj.selectedIndex=i;
				return;
			}
		}
	};
	$.find=function(id){
		return document.getElementById(id);
	};
	$.CE=function(tag,id, htm, append){
		var o=document.createElement(tag);
		if(id)o.id=id;
		if(htm)o.innerHTML=htm;
		if(append) document.body.appendChild(o);
		return o;
	};
	$.pop=function(obj,relateObj){
		if(tqEditor.activePop==obj){
			$.hidePop();
			return false;
		}
		$._hideContext();
		$.hidePop();
		tqEditor.activePop=obj;
		obj.relateObj=relateObj;
		relateObj.className='eButtonDropDown';

		obj.style.display='block';
		var p=$._pos(relateObj);
		var l=p.x;//$._objLeft(relateObj);
		var t= 1+relateObj.clientHeight +p.y;//$._objTop(relateObj);
		var dl = $._docScrollLeft();
		var w =  document.documentElement.clientWidth || document.body.clientWidth;
		if(l+obj.offsetWidth>dl+w)l-=obj.offsetWidth-relateObj.offsetWidth;
		obj.style.left= l + 'px';
		obj.style.top = t+ 'px';
		return true;
	};
	$.hidePop=function(){
		if(!tqEditor.activePop) return;
		var o=tqEditor.activePop;
		tqEditor.activePop=null;
		o.style.display='none';
		if(o.relateObj && o.relateObj.className=='eButtonDropDown') o.relateObj.className='eButton';
		
		var o=$.find('ColorPicker');
		if(o)o.style.display='none';
	};
	$._pos=function(e){
		var x = 0;
		var y = 0;
		if (e.getBoundingClientRect) {
			var box = e.getBoundingClientRect();
			var d=$._doc();
			x = box.left + $._docScrollLeft() - d.clientLeft;
			y = box.top + $._docScrollTop() - d.clientTop;
		} else {
			x = e.offsetLeft;
			y = e.offsetTop;
			var parent = e.offsetParent;
			while (parent) {
				x += parent.offsetLeft;
				y += parent.offsetTop;
				parent = parent.offsetParent;
			}
		}
		//if(isWebkit ){ //新版已修正
		//	x += $._docScrollLeft();
		//	y += $._docScrollTop();
		//}
		return {'x' : x, 'y' : y};
	};
	$.exeCmd=function(cmd,para){
		$.focus();
		try{$._getDoc().execCommand(cmd,false, para!=null?para:false);}catch(e){}
	};
	$.focus=function(){
		if('visual'==$.currentMode()){
			$._editorObj().contentWindow.focus();
		}else{
			$._editorObj().focus();
		}
	};
	$.delListener=function(e,eventName,func){
		if(e.removeEventListener) {
			e.removeEventListener(eventName, func, false );
		}else{
			e.detachEvent('on'+eventName, e['e'+eventName+func]);
		}
	};
	$.addListener=function(e,eventName,func){
		if(e.addEventListener) {
			e.addEventListener( eventName, func, false );
		}else{
			e['fn'+func]=func;
			e['e'+eventName+func]=function(et){e['fn'+func](et)};
			e.attachEvent('on'+eventName, e['e'+eventName+func]);//
		}
	};
	$._colorPickerUI=function(){
		var ColorHex=['00','33','66','99','CC','FF'];
		var SpColorHex=['FF0000','00FF00','0000FF','FFFF00','00FFFF','FF00FF'];
		var w=191;//1+19*10
		var colorTable='<table width="'+w+'" cellpadding=0 ';
		colorTable += isIE ? 'cellspacing=1 border=0 bgcolor="#000000;">':'cellspacing=0 border=1 style="border-collapse:collapse;" >';
		for (i=0;i<2;i++){
			for (j=0;j<6;j++){
				colorTable += '<tr height=10>';
				//colorTable += '<td bgcolor="#000" name="'+name+'" ></td>';

				if (i>0) colorTable += '<td bgcolor="#'+SpColorHex[j]+'" name="'+name+'"></td>';
				else colorTable += '<td bgcolor="#'+ColorHex[j]+ColorHex[j]+ColorHex[j]+'" ></td>';

				//colorTable += '<td bgcolor="#000"></td>';
				for (k=0;k<3;k++){
					for (l=0;l<6;l++){
						//立方色
						colorTable += '<td bgcolor="#'+ColorHex[k+i*3]+ColorHex[l]+ColorHex[j]+'" ></td>';
						//连续色
						//var c1 = 4+i-k*2;
						//var c2 = i*j + (1-i)*(5-j);// i?j:5-j
						//var c3 = k!=1? 5-l:l;      //k!=1? 5-l:l;
						//colorTable += '<td bgcolor="#'+ColorHex[c1]+ColorHex[c2]+ColorHex[c3]+'"></td>';
					}
				}
				colorTable += '</tr>';
			}
		}
		colorTable +='</table>';
		colorTable +='<div style="padding:2px 2px 1px 2px;line-height:25px;"><div style="height:25px;width:60px;display:block;float:left; margin-right:5px;" name=colorPreview></div><span name="colorValue"></span></div>';
		return colorTable;
	};
	$._showParagraphUI=function(sender){
		var o=$.find($.objId+'Paragraph');
		if(null==o){
			var s='',fs=$.config.paragraphs;
			for(var i=0;i < fs.length; i++){
				s +='<div name="FormatBlock" class="eMenuItem" unselectable=on onselectstart="return false" paraValue="'+fs[i][1]+'">'+fs[i][0]+'</div>';
			}
			o = $.CE('DIV',$.objId+'Paragraph',s,true);
			o.className='ePopPanel';
			$._noSel(o);//,'DIV'
			$.listenTagEvent(o,'DIV','click',function(){
				$.hidePop();
				var pv=this.getAttribute('paraValue');
				if(isIE)pv ='<'+pv+'>';
				$.exeCmd('FormatBlock', pv);
			});
			if(isIE6){ 
				var es = $._children(o,'DIV');
				for(var i=es.length-1;i>=0;i--){
					$._ieMouseStyle(es[i],'eMenuItem','eMenuItemUp','eMenuItem');
				}
			}
		}
		$.pop(o,sender);
	};
	$._showFontSizeUI=function(sender){
		var o=$.find($.objId+'FontSize');
		if(null==o){
			var s='',fs=$.config.fontsizes;
			for(var i=0;i < fs.length; i++){
				s +='<div name="FontSize" class="eMenuItem" unselectable=on onselectstart="return false" paraValue="'+fs[i][2]+'" style="font-size:'+fs[i][1]+';" >'+fs[i][0]+'</div>';
			}
			o = $.CE('DIV',$.objId+'FontSize',s,true);
			o.className='ePopPanel';
			$._noSel(o);//,'DIV'
			$.listenTagEvent(o,'DIV','click',function(){$.hidePop();$.exeCmd('FontSize', this.getAttribute('paraValue'))});
			if(isIE6){ 
				var es = $._children(o,'DIV');
				for(var i=es.length-1;i>=0;i--){
					$._ieMouseStyle(es[i],'eMenuItem','eMenuItemUp','eMenuItem');
				}
			}
		}
		$.pop(o,sender);
	};
	$._showFontNamesUI=function(sender){
		var o=$.find($.objId+'FontName');
		if(null==o){
			var s='',fs=$.config.fontnames;
			for(var i=0;i < fs.length; i++){
				s +='<div name="FontName" class="eMenuItem" unselectable=on onselectstart="return false"  paraValue="'+fs[i][1]+'"  style="font-family:'+fs[i][1]+';" >'+fs[i][0]+'</div>';
			}
			o = $.CE('DIV',$.objId+'FontName',s,true);
			o.className='ePopPanel';
			$._noSel(o);//,'DIV'
			$.listenTagEvent(o,'DIV','click',function(){$.hidePop();$.exeCmd('FontName', this.getAttribute('paraValue'))});
			if(isIE6){ 
				var es = $._children(o,'DIV');
				for(var i=es.length-1;i>=0;i--){
					$._ieMouseStyle(es[i],'eMenuItem','eMenuItemUp','eMenuItem');
				}
			}
		}
		$.pop(o,sender);
	};
	$.pickColor=function(callbackFunc,x,y){
		var o=$.find('ColorPicker');
		if(null==o){
			o = $.CE('DIV','ColorPicker', $._colorPickerUI() ,true);
			o.className='ePopPanel';
			o.style.zIndex=99999999;
			o.onmouseover=function(){this.active=true;};
			o.onmouseout=function(){this.active=false;};

			$._noSel(o);//,'TABLE,TR,TD,DIV');
			$.listenTagEvent(o,'TD','mouseover',function(){
				var p=this.parentNode.parentNode.parentNode.parentNode.lastChild;
				p.firstChild.style.backgroundColor=this.bgColor;
				p.lastChild.innerHTML=this.bgColor;

				this.style.backgroundColor='#FFFFFF';
				var self=this;
				var iid = window.setInterval(function(){self.style.backgroundColor=(self.style.backgroundColor!='')?'':'#FFFFFF'},500);
				this.onmouseout=function(){window.clearInterval(iid);this.style.backgroundColor='';}
			});

			$.listenTagEvent(o,'TD','mouseup',function(){this.parentNode.parentNode.parentNode.parentNode.style.display='none';});
			$.addListener(document,'mousedown',function(){var o=$.find('ColorPicker');if(!o.active)o.style.display='none';});
		}
		var ds = $._children(o,'TD');
		for(var i=ds.length-1;i>=0;i--){
			ds[i].onmousedown=function(){callbackFunc(this.bgColor);}
		}
		o.style.left=x+'px';
		o.style.top=y+'px';
		o.style.display='block';
	};
	$._showColorSelectUI=function(sender,cmd){
		var o=$.find($.objId+'ColorSelect'+cmd);
		if(null==o){
			o = $.CE('DIV',$.objId+'ColorSelect'+cmd, $._colorPickerUI() ,true);
			o.className='ePopPanel';
			$._noSel(o);//,'TABLE,TR,TD,DIV');
			$.listenTagEvent(o,'TD','click',function(){$.hidePop();$.exeCmd(cmd, this.bgColor);});
			$.listenTagEvent(o,'TD','mouseover',function(){
				var p=this.parentNode.parentNode.parentNode.parentNode.lastChild;
				p.firstChild.style.backgroundColor=this.bgColor;
				p.lastChild.innerHTML=this.bgColor;

				this.style.backgroundColor='#FFFFFF';
				var self=this;
				var iid = window.setInterval(function(){self.style.backgroundColor=(self.style.backgroundColor!='')?'':'#FFFFFF'},500);
				this.onmouseout=function(){window.clearInterval(iid);this.style.backgroundColor='';}
			});
		}
		$.pop(o,sender);
	};
	$._showButtonAsMenuUI=function(sender, btns){
		var cmd=sender.getAttribute('name');
		var o=$.find($.objId+'PopMenu'+cmd);
		if(null==o){
			o = $.CE('DIV',$.objId+'PopMenu'+cmd, '' ,true);
			o.className='ePopPanel';
		}
		var s='';
		for(var i=0; i < btns.length; i++){
			var tn = btns[i];
			if('separator'==tn || '|'==tn){
				s +='<hr style="width:120px; clear:both;" />';
				continue;
			}
			bn = $.buttonList[tn];
			if(!bn) continue;
			if(bn){
				s +='<div id="'+$.objId+'_'+bn[0]+'" name="'+bn[0]+'" class="eMenuItem" ><span class="eButton" style="background-position: -'+bn[2]+'px 0;width:'+bn[3]+'px;'+bn[5]+'" ></span>'+bn[1]+'</div>';
			}
		}
		o.innerHTML=s;
		$._noSel(o);
		if(isOpera)$._noSel(o,'DIV');
		$.listenTagEvent(o,'DIV','click',$._toolbarBottonClick);
		if(isIE6){ 
			var es = $._children(o,'DIV');
			for(var i=es.length-1;i>=0;i--){
				$._ieMouseStyle(es[i],'eMenuItem','eMenuItemUp','eMenuItem');
			}
		}
		$.pop(o,sender);
	};
	$._showInsertFacetUI=function(sender){
		var o=$.find($.objId+'InsertFace');
		if(null==o){
			var s='<div class="eFace">';
			for(var i=1;i<=$.config.faceCount;i++){
				s+='<img src="'+tqEditor.url+'face/'+i+'.gif" emot="'+i+'" />';
			}
			s+='</div>';
			o = $.CE('DIV',$.objId+'InsertFace', s ,true);
			o.className='ePopPanel';
			$._noSel(o);//,'IMG,DIV'); 
			$.listenTagEvent(o,'IMG','click',function(){$.hidePop();$.insertHtml('<img align=absMiddle src="'+this.src+'" emot="'+this.getAttribute('emot')+'" />');});
			if(isIE6){ 
				var es = $._children(o,'IMG');
				for(var i=es.length-1;i>=0;i--){
					$._ieMouseStyle(es[i],'','imgHover','');
				}
			}
		}
		$.pop(o,sender);
	};
	$._uploadBtn=function(url,fileTypes,mutilFiles){
		return '<button  type="button" value="上传" id="uploadBtn" name="uploadBtn"  class="eBtn" >上传</button>';
	};
	$.__formUIInit=function(id, caption, htm, cbOK, intInputNames, uploadUrl, uploadFileTypes, uploadFileSize, isImage){
		var s='<form  class="ePopForm">';
		if(uploadUrl){
			s+='<div class="eTabBar"><a href="javascript:void(0)" class="active" HIDEFOCUS="true">'+caption+'</a><a href="javascript:void(0)" HIDEFOCUS="true">上传</a></div>';
			s+='<div>';
		}
		s += htm;
		s+='<div class="eBar"><button  id="OK"  name="OK"  type="button" class="eBtn"  HIDEFOCUS="true"/>确定</button> &nbsp; <button id="Cancel" name="Cancel" type="button" class="eBtn"  HIDEFOCUS="true">取消</button></div>';
		if(uploadUrl){
			s+='</div><div style="display:none">';
			var url=uploadUrl;
			if(uploadUrl.substr(0,1)=='#'){//自定上传界面
				url=uploadUrl.substring(1);
			}else{
				//修正相对网址
				if(!('http://'==uploadUrl.substr(0,7).toLowerCase() || '/'==uploadUrl.substr(0,1) || 'https://'==uploadUrl.substr(0,6).toLowerCase())){
					if('?'==uploadUrl.substr(0,1)){
						uploadUrl = location.pathname+uploadUrl;
					}else{
						var a=location.pathname.split('/');
						a[a.length-1]= uploadUrl;
						uploadUrl = a.join('/');
					}
				}
				url=tqEditor.url+'upload.htm?url='+encodeURIComponent(uploadUrl)+'&field_name='+$.config.uploadFieldName+'&exts='+encodeURIComponent(uploadFileTypes)+'&max_size='+encodeURIComponent(uploadFileSize)+'&debug='+$.config.debug+'&is_image='+isImage;
			}
			s+='<iframe src="'+url+'" frameborder=0 width=358 height=45 ALLOWTRANSPARENCY=true ></iframe>';
			s+='</div>';
		}
		
		s +='</form>';

		var o= $.CE('DIV',id, s ,true);
		o.className='ePopPanel';

		if(uploadUrl){
			var tabClick=function(){
				this.className='active';
				if(this.nextSibling){
					this.nextSibling.className='';
					this.parentNode.nextSibling.style.display='';
					this.parentNode.nextSibling.nextSibling.style.display='none';
				}else if(this.previousSibling){
					this.previousSibling.className='';
					this.parentNode.nextSibling.style.display='none';
					this.parentNode.nextSibling.nextSibling.style.display='';
				}
			};
			var tabbar = o.firstChild.firstChild;
			tabbar.firstChild.onclick=tabClick;
			tabbar.lastChild.onclick=tabClick;
		}
		var f= $._children(o,'FORM')[0];
		f.srcEditor=$;
		var es = f.elements;
		es['Cancel'].onclick= $.hidePop;
		es['OK'].onclick=cbOK;
		if(intInputNames) for(i=intInputNames.length-1;i>=0;i--) $._intEdit(es[intInputNames[i]]);
		$._noSel(o);
		if(isOpera)$._noSel(o,'FORM,DIV');
		return o;
	};
	$._showCreateLinkUI=function(sender){
		var o=$.find($.objId+'CreateLink');
		if(null==o){
			var s='网址:<input type="text" id="url" value="" size=45 /><br />打开:<select id="target"><option value="" >默认</option><option value="_blank">新窗口</option><option value="_self">当前窗口</option><option value="_parent">父窗口</option><option value="_top">顶层窗口</option></select>';
			var okClick= function(){
				$.hidePop();
				var es=this.form.elements;
				var href=es['url'].value;
				var target=es['target'].value;
				if('http://'==href || ''==href){
					$.exeCmd('Unlink');
					return;
				}
				$.exeCmd('CreateLink', href);
				var r = $._getRange();
				var n=r.parentElement();
				do{
					if(n.tagName=='A'){
						if(''==target) n.removeAttribute('target') ;
						else n.setAttribute('target',target);
						break;
					}
				}while(n = n.parentNode);
			};
			o = $.__formUIInit($.objId+'CreateLink','添加链接', s, okClick,null, $.config.linkUploadUrl,$.config.linkFileTypes,$.config.linkFileSize,false);
		}
		if(!$.pop(o,sender)) return;

		var f = $._children(o,'FORM')[0];
		f.reset();
		var es = f.elements;
		var r = $._getRange();
		var n;
		if(isIE){
			n = (r.length)? r.item(0).parentNode : r.parentElement();
		}else{
			n = $._getSelection().focusNode;
		}
		do{
			if(n.tagName=='A'){
				es['url'].value=n.href;
				$.__selectOption(es['target'],n.getAttribute('target'));
				break;
			}
		}while(n = n.parentNode);

	};
	$._showInsertImageUI=function(sender){
		var o=$.find($.objId+'InsertImage');
		if(null==o){
			var s='图片网址:<input type="text" id="url" value="" size=40 /><br />替换文本:<input name="alt" type="text" id="alt" size="20" /><br />尺寸:<input name="width" type="text" id="width" size="4" /> &times; <input name="height" type="text" id="height" size="4" /> px &nbsp;<br />对齐:<select name="align" id="align"><option value="" >默认</option><option value="top">居上</option><option value="textTop">文本上方</option><option value="middle">居中</option><option value="absMiddle">绝对居中</option><option value="baseline">基线</option><option value="bottom">底部</option><option value="absBottom">绝对底部</option><option value="left">左</option><option value="right">右</option></select> &nbsp; &nbsp; 边框:<input name="border" type="text" id="border" size="5" />';
			var okClick=function(){
				$.hidePop();
				var es=this.form.elements;
				$.insertImage(es['url'].value,es['width'].value,es['height'].value,es['border'].value, es['alt'].value,es['align'].value);
				};
			o = $.__formUIInit($.objId+'InsertImage','插入图片', s, okClick ,['width','height','border'], $.config.imageUploadUrl,$.config.imageFileTypes, $.config.imageFileSize, true);
		}
		if(!$.pop(o,sender)) return;
		var f = $._children(o,'FORM')[0];
		f.reset();
		var es = f.elements;
		var r=$._getRange();
		var n;
		if(isIE && r.length && r.item(0).tagName=='IMG'){
			n=r.item(0);
		}else if(!isIE){
			n=r.commonAncestorContainer;
			if(!r.collapsed && r.startContainer == r.endContainer && r.startOffset - r.endOffset < 2 && r.startContainer.hasChildNodes()){
				n=r.startContainer.childNodes[r.startOffset];
			}
			if(n.tagName!='IMG') n=null; 
		}
		if(n){
			 es['url'].value=n.getAttribute('src');
			 es['width'].value=n.width;
			 es['height'].value=n.height;
			 es['border'].value=n.border;
			 es['alt'].value=n.alt;
			 $.__selectOption(es['align'],n.align);
		}
	};
	$._showInsertTableUI=function(sender){
		var o=$.find($.objId+'InsertTable');
		if(null==o){
			var s='行数:<input name="row" type="text" id="row" value="3" size="5" /> 列数:<input name="col" type="text" id="col" value="5" size="5" /><br />对齐:<select name="align" id="align"><option value="" >默认</option><option value="left">左</option><option value="center">中</option><option value="right">右</option></select><br />宽度:<input name="width" type="text" id="width" value="100%" size="5" /><br />间距:<input name="cellspace" type="text" id="cellspace" value="0" size="5" /><br />填充:<input name="cellpadding" type="text" id="cellpadding" value="3" size="5" /><br />背景色:<input name="bgcolor" type="text" id="bgcolor" value="" size="7" /><br />边框色:<input name="bordercolor" type="text" id="bordercolor" value="" size="7" />';
			var okClick=function(){
				$.hidePop();
				var es=this.form.elements;
				var s='<table style="border-collapse:collapse;" border=1 ';
				if(!isNaN(parseInt(es['cellspace'].value))) s+=' cellspace='+parseInt(es['cellspace'].value);
				if(!isNaN(parseInt(es['cellpadding'].value))) s+=' cellpadding='+parseInt(es['cellpadding'].value);
				if(''!=es['width'].value) s+=' width='+es['width'].value;
				if(''!=es['align'].value) s+=' align='+es['align'].value;
				if(''!=es['bordercolor'].value) s+=' bordercolor='+es['bordercolor'].value;
				if(''!=es['bgcolor'].value) s+=' bgcolor='+es['bgcolor'].value;
				s +='>';
				for(var i=parseInt(es['row'].value);i>0;i--){
					s+'<tr>';
					for(var j=parseInt(es['col'].value);j>0;j--){
						s+= isGecko ? '<td><br /></td>':'<td></td>';	 
					}
					s+='</tr>';
				}
				s+='</table>';
				$.insertHtml(s);
			};
			o = $.__formUIInit($.objId+'InsertTable','插入表格', s, okClick ,['row','col','cellspace','cellpadding']);
			var f= $._children(o,'FORM')[0];
			var es = f.elements;
			es['bordercolor'].onclick=function(){
				var p = $._pos(this);
				var l=p.x;//$._objLeft(this);
				var t= 5+this.clientHeight + p.y;//$._objTop(this);
				var obj=this;
				$.pickColor(function(color){obj.value=color;},l,t);
			};
			es['bordercolor'].onblur=function(){var o=$.find('ColorPicker');if(o)o.style.display='none';};
			es['bgcolor'].onclick= es['bordercolor'].onclick;
			es['bgcolor'].onblur= es['bordercolor'].onblur;
		}
		if(!$.pop(o,sender)) return;
		var f = $._children(o,'FORM')[0];
		f.reset();
		//f.elements['row'].focus();
	};
	$._showInsertMusicUI=function(sender){
		var o=$.find($.objId+'InsertMusic');
		if(null==o){
			var s='音频网址:<input type="text" id="url" value="" size=40 /><br />自动播放:<select id="auto_start" name="auto_start"><option value="0">手动开始</option><option value="1">自动开始</option></select>';
			var okClick= function(){
				$.hidePop();
				var es=this.form.elements;
				$.insertMusic(es['url'].value,es['auto_start'].value);
			};
			o = $.__formUIInit($.objId+'InsertMusic','插入音频', s, okClick,null, $.config.musicUploadUrl,$.config.musicFileTypes,$.config.musicFileSize, false);
		}
		if(!$.pop(o,sender)) return ;
		var f = $._children(o,'FORM')[0];
		f.reset();
		//f.elements['url'].focus();

	};
	$.insertMusic=function(url,auto_start){
		var s = $.config.tplMusic.replace(/\{\$url\}/g,url).replace(/\{\$auto_start\}/g,auto_start);
		$.insertHtml(s);
	};
	$._showInsertFlashUI=function(sender){
		var o=$.find($.objId+'InsertFlash');
		if(null==o){
			var s='Flash网址:<input type="text" id="url" value="" size=40 /><br />尺寸:<input name="width" type="text" id="width" size="4" value="100" />&times;<input name="height" type="text" id="height" size="4" value="100" /> px';

			var okClick= function(){
				$.hidePop();
				var es=this.form.elements;
				$.insertFlash(es['url'].value,es['width'].value,es['height'].value);
			};
			o = $.__formUIInit($.objId+'InsertFlash','插入Flash', s, okClick,['width','height'], $.config.flashUploadUrl,$.config.flashFileTypes,$.config.flashFileSize, false);
		}
		if(!$.pop(o,sender)) return;
		var f = $._children(o,'FORM')[0];
		f.reset();
		//f.elements['url'].focus();
	};
	$.insertFlash=function(url,width,height){
		var s = $.config.tplFlash.replace(/\{\$url\}/g,url);
		s = s.replace(/\{\$width\}/g,width);
		s = s.replace(/\{\$height\}/g,height);
		$.insertHtml(s);
	};
	$._showInsertFlvUI=function(sender){
		var o=$.find($.objId+'InsertFlv');
		if(null==o){
			var s='Flv 网址:<input type="text" id="url" value="" size=40 /><br />尺寸:<input name="width" type="text" id="width" size="4"  value="320"/>&times;<input name="height" type="text" id="height" size="4" value="240" /> px<br />自动播放:<select id="auto_start" name="auto_start"><option value="0">手动开始</option><option value="1">自动开始</option></select>';
			var okClick= function(){
				$.hidePop();
				var es=this.form.elements;
				$.insertFlv(es['url'].value,es['auto_start'].value,es['width'].value,es['height'].value);
			};
			o = $.__formUIInit($.objId+'InsertFlv','插入Flv视频', s, okClick,['width','height'], $.config.flvUploadUrl,$.config.flvFileTypes,$.config.flvFileSize, false);
		}
		if(!$.pop(o,sender)) return;

		var f = $._children(o,'FORM')[0];
		f.reset();
		//f.elements['url'].focus();
	};
	$.insertFlv=function(url,auto_start,width,height){
		var s = $.config.tplFlv.replace(/\{\$url\}/g,url);
		s = s.replace(/\{\$auto_start\}/g,auto_start);
		s = s.replace(/\{\$width\}/g,width);
		s = s.replace(/\{\$height\}/g,height);
		$.insertHtml(s);
	};
	$._showInsertRmUI=function(sender){
		var o=$.find($.objId+'InsertRm');
		if(null==o){
			var s='Rmvb网址:<input type="text" id="url" value="" size=40 /><br />尺寸:<input name="width" type="text" id="width" size="4" value="320"/>&times;<input name="height" type="text" id="height" size="4" value="240" /> px<br />自动播放:<select id="auto_start" name="auto_start"><option value="0">手动开始</option><option value="1">自动开始</option></select>';

			var okClick= function(){
				$.hidePop();
				var es=this.form.elements;
				$.insertRm(es['url'].value,es['auto_start'].value,es['width'].value,es['height'].value);
			};
			o = $.__formUIInit($.objId+'InsertRm', '插入RM视频',s, okClick,['width','height'], $.config.rmUploadUrl,$.config.rmFileTypes,$.config.rmFileSize, false);
		}
		if(!$.pop(o,sender)) return;

		var f = $._children(o,'FORM')[0];
		f.reset();
		//f.elements['url'].focus();
	};
	$.insertRm=function(url,auto_start,width,height){
		var s = $.config.tplRm.replace(/\{\$url\}/g,url);
		s = s.replace(/\{\$auto_start\}/g,auto_start);
		s = s.replace(/\{\$width\}/g,width);
		s = s.replace(/\{\$height\}/g,height);
		$.insertHtml(s);
	};
	$._showInsertVideoUI=function(sender){
		var o=$.find($.objId+'InsertVideo');
		if(null==o){
			var s='视频网址:<input type="text" id="url" value="" size=40 /><br />尺寸:<input name="width" type="text" id="width" size="4"  value="320"/>&times;<input name="height" type="text" id="height" size="4" value="240" /> px<br />自动播放:<select id="auto_start" name="auto_start"><option value="0">手动开始</option><option value="1">自动开始</option></select>';
			var okClick= function(){
				$.hidePop();
				var es=this.form.elements;
				$.insertVideo(es['url'].value,es['auto_start'].value,es['width'].value,es['height'].value);
			};
			o = $.__formUIInit($.objId+'InsertVideo','插入Window视频', s, okClick,['width','height'], $.config.videoUploadUrl,$.config.videoFileTypes,$.config.videoFileSize, false);
		}
		if(!$.pop(o,sender)) return;

		var f = $._children(o,'FORM')[0];
		f.reset();
		//f.elements['url'].focus();
	};
	$.insertVideo=function(url,auto_start,width,height){
		var s = $.config.tplVideo.replace(/\{\$url\}/g,url);
		s = s.replace(/\{\$auto_start\}/g,auto_start);
		s = s.replace(/\{\$width\}/g,width);
		s = s.replace(/\{\$height\}/g,height);
		$.insertHtml(s);
	};
	$._showHelpUI=function(sender){
		var o=$.find($.objId+'TQHelpPanel');
		if(null==o){
			var s='<form class="ePopForm" style="line-height:20px;">TQEditor<br/>版本: '+tqEditor.version+'<br/>作者: 李腾秋<br/>官网: <a href="http://www.e512.net" target="_blank">e512.net</a><br />邮箱: <a href="mailto:litqqs@163.com">litqqs@163.com</a><br /><a href="tencent://message/?uin=7775038&Site=e512.net&Menu=no" style="clear:both;"><span class="eButton" style="background-position: -1050px 0;width:20px;" ></span> 7775038</a></form>';
			o = $.CE('DIV',$.objId+'TQHelpPanel', s ,true);
			o.className='ePopPanel';
		}
		$.pop(o,sender);
	};
	//position 可选值[before|after|replace|-1|1|0]
	$.insertHtml=function(htm,position){
		$.focus();
		var r = $._getRange();
		if(r.length){  //ie
			var d=$._getDoc();
			var e=r.item(0);
			var tr=d.body.createTextRange();
			tr.moveToElementText(e);
			if('before'==position || -1==position){
				tr.collapse();
			}else if('after'==position || 1==position){
				tr.collapse(false);
			}else{
				r.execCommand('Delete');
			}
			tr.pasteHTML(htm);
			tr.select();//重设光标
		}else if(r.insertNode){
			var cf;
			if(r.createContextualFragment){//IE9 未实现此方法
				cf=r.createContextualFragment(htm);
			}else{
				cf =$._getDoc().createDocumentFragment();
				cf.appendChild($.CE('div'));
				cf.firstChild.outerHTML=htm;
			}

			if('before'==position || -1==position){
				var n= cf.lastChild;
				r.insertNode(cf);
				r.setEndAfter(n);
			} else if('after'==position || 1==position){
				r.collapse(false);
				r.insertNode(cf);
			}else{
				r.deleteContents();
				r.insertNode(cf);
			}
			r.collapse(false);
			var sel	= $._getSelection();
			sel.removeAllRanges();
			sel.addRange(r);
		}else{
			if('before'==position || -1==position){
				r.collapse(true);
			}else if('after'==position || 1==position){
				r.collapse(false);
			}
			r.pasteHTML(htm);
			r.collapse(false);
			r.select();
		}
	};
	$._editorObj= function(){
		return  $.find($.objId+'_Editor');
	};
	$.currentMode=function(){//取得当前的编辑模式, code 代码 , visual 可视化
		return ($._editorObj().tagName.toUpperCase()=='IFRAME')?'visual':'code';
	};
	$._getDoc=function(){
		var iframe =$._editorObj();
		return iframe.contentDocument || iframe.contentWindow.document;
	};
	$._getSelection=function(){
		var win =$._editorObj().contentWindow;
		return (win.getSelection) ? win.getSelection() : $._getDoc().selection;
	};
	$._getRange=function(){
		var selection=$._getSelection(), d=$._getDoc(),r;
		try{//标准dom
			r = selection.rangeCount > 0 ? selection.getRangeAt(0) : (selection.createRange ? selection.createRange() : d.createRange());
		}catch (e){}
		if(!r) r = isIE ? d.body.createTextRange() : d.createRange();
		return r;
	};
	$.insertImage=function(image_url,width,height,border,alt,align){
		if(''==image_url) return;
		var s='<img src="'+image_url+'" ';
		if(width!=undefined && ''!=width && !isNaN(parseInt(width)) && parseInt(width)>0 ) s += ' width='+parseInt(width);
		if(height!=undefined && ''!=height && !isNaN(parseInt(height)) && parseInt(height)>0 ) s +=' height='+parseInt(height);
		if(border!=undefined && ''!=border && !isNaN(parseInt(border))) s +=' border='+parseInt(border);
		if(alt!=undefined && ''!=alt) s +=' alt="'+alt+'"';
		if(align!=undefined && ''!=align) s +=' align="'+align+'"';
		s +=' />';
		$.insertHtml(s); 
		return;
	};
	$._enableButton=function(btn,enable){
		if(enable){
			btn.disabled=false;
			$.setOpacity(btn,100);
			$.addListener(btn,'click',$._toolbarBottonClick);
		}else{
			btn.disabled=true;
			$.setOpacity(btn,30);
			$.delListener(btn,'click',$._toolbarBottonClick);
		}
	};
	$._updateToolbar=function(enable, buttons, exceptFlag){
		var tb=$._toolbarDiv;
		var btns = $._children(tb,'LI');
		for(var i=btns.length-1;i>=0;i--){
			if($.inArray(btns[i].getAttribute('name'), buttons) ^ exceptFlag  ) {//	
				$._enableButton(btns[i],enable);
			}
		}
	};
	$._hook=function(){
		if('visual'!=$.currentMode()) return; //!isIE || !$.config.enter2br || 
		var doc=$._getDoc();
		doc.onkeydown = function(e){
			$._hideContext();
			if(isIE) e = $._editorObj().contentWindow.event;
			var key = e.keyCode || e.which;
			if(key==13){
				var r= $._getRange();
				var o = r.parentElement ? r.parentElement():r.commonAncestorContainer.parentNode;
				if(o.className == 'splitPage'){//分页标题
					var p=o.parentNode;
					var br = document.createElement('BR');
					if(p.lastChild == o){
						p.appendChild(br);
					}else{
						p.insertBefore(br,o.nextSibling);
					}
					//重设光标
					var d=$._getDoc(), tr;
					if(isIE){
						tr=d.body.createTextRange();
						tr.moveToElementText(br)
						tr.collapse(true);
						tr.select();
					}else{	
						tr = d.createRange();
						tr.selectNode(br);
						tr.collapse(true);
						var sel	= $._getSelection();
						sel.removeAllRanges();
						sel.addRange(tr);
					}
					return false;
				}
				//--
				//if(e.shiftKey){e.shiftKey=false;return true;}
				if($.config.enter2br){
					if($._getRange().parentElement().tagName != 'LI'){
						$.insertHtml('<br />');
						return false;
					}
				}
			}
		};
		doc.ondragstart=function(e){$._hideContext();};
		doc.onclick=function(e){
			$._hideContext();
			$.focus();
			if(!isIE){
				if(e.target.tagName=='IMG'){
					var r = $._getDoc().createRange();
					r.selectNode(e.target);
					var sel	= $._getSelection();
					sel.removeAllRanges();
					sel.addRange(r);
					$._popImgContextPanel(e.target);
				}
			}else{
				e=$._editorObj().contentWindow.event;
				if(e.srcElement.tagName=='IMG'){
					$._popImgContextPanel(e.srcElement);
				}
			}
		};
		if(isIE){
			doc.onmousedown=doc.onclick;
			doc.onclick=null;
		}
		//doc.oncontextmenu=function(e){return false;};
	};
	$._popImgContextPanel=function(img){
		var o=$.find('__tqImgContextPanel');
		if(null==o){
			var s='<form class="ePopForm">网址: <input type="text" id="url" size="50"><br>尺寸: <input  type="text" id="width" style="width:30px; overflow:visible;"> &times; <input  type="text" id="height" style="width:30px; overflow:visible;">px <a href="javascript:void(0)" id="resetWH" >重设大小</a><label><input name="lock" type="checkbox" id="lock" value="1" checked>锁定比例</label><br>排版: <a href="javascript:void(0)" id="alignDefault">默认</a> | <a href="javascript:void(0)" id="alignLeft">左浮动</a> | <a href="javascript:void(0)" id="alignC">居中</a> | <a href="javascript:void(0)" id="alignRight">右浮动</a> | <a href="javascript:void(0)" id="alignTop">上对齐</a> | <a href="javascript:void(0)" id="alignAbsMiddle">中对齐</a> | <a href="javascript:void(0)" id="alignBottom">下对齐</a></form>';
			o= $.CE('DIV','__tqImgContextPanel', s ,true);
			o.className='ePopPanel';
			var f= $._children(o,'FORM')[0];
			var es = f.elements;
			$._intEdit(es['width']);
			$._intEdit(es['height']);

			o.urlField=es['url'];
			o.widthField=es['width'];
			o.heightField=es['height'];
			o.lockField=es['lock'];

			o.urlField.onchange=function(){
				this.parentNode.parentNode.target.src=this.value;;
			};
			o.urlField.onfocus=function(){this.select();};
			var setwh=function(){
				var o=this.parentNode.parentNode, w=h=Math.max(1,this.value);
				if(o.lockField.checked){
					if(this.id=='width') h=o.heightField.value=Math.round(w/ o.rate);
					else w=o.widthField.value=Math.round(h * o.rate);
				}else{
					if(this.id=='width') h=o.heightField.value;
					else w=o.widthField.value;
				}
				o.target.width=w;
				o.target.height=h;
				o.target.style.width='';
				o.target.style.height='';
			};
			o.widthField.onchange=o.widthField.onblur=o.heightField.onchange=o.heightField.onblur=setwh;

			o.lockField.onclick=function(){
				if(this.checked){
					var o=this.parentNode.parentNode.parentNode; 
					o.rate=o.widthField.value/o.heightField.value;
				}
			};

			var aClick=function(e){
				var op=this.parentNode.parentNode;
				var o=op.target;
				var id=this.id;
				if('resetWH'==id){
					o.removeAttribute('width');
					o.removeAttribute('height');
					o.style.width='';
					o.style.height='';
					op.widthField.value=o.width;
					op.heightField.value=o.height;
					op.rate=o.width/o.height;
				}else{ // if('align'==id.substring(0,5)){
					o.align='';
					o.style.display='';
					o.style.margin='';
					if('alignC'==id){
						o.style.display='block';
						o.style.margin='5px auto';
					}else{
						o.align=id.substring(5,20).toLowerCase();;
					}
				}
				return false;
			};
			var os = $._children(o,'A');
			for(var i=os.length-1;i>=0;i--){
				os[i].onclick=aClick;
			}
			$._noSel(o);
		}
		o.target=img;
		o.urlField.value=img.getAttribute('src');
		o.widthField.value=img.width;
		o.heightField.value=img.height;
		o.rate= (img.width>0 && img.height>0) ? img.width / img.height:1;
		$._popContext(o, img);
	};
	$._popContext=function(o,relateObj){
		if(tqEditor.activeContext != o )$._hideContext();
		var x,y,p=$._pos($._editorObj()),p2=relateObj.getBoundingClientRect();
		var d=$._doc();

		o.style.display="block";
		x = Math.min( p.x+ p2.left , $._docScrollLeft() + d.clientWidth-o.offsetWidth-5);
		y =  10+p.y+ p2.bottom;
		var my=	$._docScrollTop() + d.clientHeight - o.offsetHeight-10; 
		if(y > my) y=p2.top+p.y-o.offsetHeight-10;
		if(y<$._docScrollTop())y=10+Math.max(p.y, $._docScrollTop());//	isIE? window.event.clientY : 
		o.style.left= x+'px';
		o.style.top= y+'px';
		tqEditor.activeContext=o;
		$.drag(o);
	};
	$._hideContext=function(){
		if(tqEditor.activeContext){
			tqEditor.activeContext.style.display="none";
			tqEditor.activeContext=null;
		}
	};
	$._changed=function(){
		$._autoSave();
		var o;
		if('visual'==$.currentMode()){
			var doc = $._getDoc();
			$.addListener(doc,'mouseup',$.hidePop);
			$._keepBookmark();
			if($.config.autoClean) doc.body.onpaste=function(){setTimeout($.cleanWord,200);};
			o=$._editorObj().contentWindow;
		}else{
			o= $._editorObj();
			$.addListener(o,'mouseup',$.hidePop);
		}
		//绑定事件
		o.onfocus=function(){if($.obj.onfocus) $.obj.onfocus();};
		o.onblur=function(){if($.obj.onblur) $.obj.onblur();};
	};
	//mode 可选值[code|visual]
	$.changeMode=function(mode){//更改编辑方式,空值时自动转另一种方式
		var old=$.currentMode();
		if(old===mode) return;
		if(!mode){
			 mode = ('code'!=old) ? 'code' : 'visual';
		}
		if(mode==old) return;
		var e,eo=$._editorObj();
		if('code'===mode){
			e = $.CE('TEXTAREA');
			e.style.width= (eo.offsetWidth-4)+'px';
			e.style.height= (eo.offsetHeight-5)+'px';
		}
		else if('visual'===mode){
			e = $.CE('IFRAME');
			e.frameBorder=0;
 			e.style.height=eo.offsetHeight-1+'px';
		}else{
			return;
		}
		e.className='eEditorClient';
		var code = $.content();
		$._clientDiv.innerHTML='';
		e.id=$.objId+'_Editor';

		$._clientDiv.appendChild(e);
		$.setContent(code);
		$._changed();
		$._hook();
		$._hideContext();
		$._updateToolbar('visual'===mode,['Mode','FullScreen','IncHeight','DecHeight','Help'], true);
	};
	//自动排版
	$.typeset=function(){
		if('visual'!=$.currentMode()) return;
		var d = $._getDoc(),e,es,s;
		es=$._children(d,'SPAN');
		for(i=es.length-1;i>=0;i--){
			e=es[i];
			e.removeNode(false);
			continue;
			if(''===e.innerHTML.replace(/<[a-z][^>]*>/gi,'')){
				e.removeNode(false);
				continue;
			}
			e.removeAttribute('style');
		}
		es=$._children(d,'P');
		var emtpyReg=/^(&nbsp;| ){3,}/
		for(i=es.length-1;i>=0;i--){
			e=es[i];
			e.removeAttribute('style');
			if(emtpyReg.test(e.innerHTML)) e.align='center';
			else e.removeAttribute('align');

		}
		es=$._children(d,'IMG');
		for(i=es.length-1;i>=0;i--){
			e=es[i];
			e.removeAttribute('style');
			e.border='0';
			e.style.margin='5px auto';
			e.style.display='block';
		}
		s=d.body.innerHTML;
		s=s.replace(/&nbsp;/gi,'');
		d.body.innerHTML=s;
	};
	//force	布尔值
	$.cleanWord=function(force){
		if('visual'!=$.currentMode()) return;
		var d = $._getDoc(),e,es,s;
		if(!force){
			if(d.body.innerHTML.indexOf('mso') <0) return;
		}
		var cleanTag=function(tag, removeOnEmptyStyle){
			var es=$._children(d,tag);
			for(i=es.length-1;i>=0;i--){
				e=es[i];
				e.removeAttribute('lang');
				s = e.getAttribute('style');
				if(null==s && removeOnEmptyStyle){
					e.removeNode(false);
					continue;
				}
				if(typeof s =='string' && s.indexOf('mso-')>=0){
					s+=';';
					s=s.replace(/mso\-[^;]+?;/gi,'');
					s=s.replace(/FONT\-FAMILY[^;]+?;/gi,'');
					s=s.replace(/\s+/g,' ');
					s=s.replace(/MARGIN\: 0cm 0cm 0pt/gi,'');
					if(''==s || ' '==s){
						if(removeOnEmptyStyle){
							e.removeNode(false);
							continue;
						}
						e.removeAttribute('style');
					}else{
						e.setAttribute('style',s);
					}
				}
				s = e.getAttribute('class');
				if(null!=s){
					s=s.replace(/mso[a-z\-]+\s*/gi,'');
					if(''==s){
						e.removeAttribute('class');
					}else{
						e.setAttribute('class',s);
					}
				}
			}
		};
		cleanTag('SPAN',true);
		cleanTag('P',false);
		cleanTag('B',false);
		cleanTag('I',false);
		cleanTag('U',false);
		cleanTag('TD',false);
		cleanTag('TR',false);
		cleanTag('TABLE',false);
		cleanTag('DIV',false);

		s=d.body.innerHTML;
		s=s.replace(/<o:[a-z0-9_]+[^>]*>/gi,'').replace(/<\/o:[a-z0-9_]+>/gi,'');
		s=s.replace(/<\?xml.+?\/>/gi,'');
		d.body.innerHTML=s;
	};
	//增或减高度
	$.changeHeight=function(delta){
		var h=parseInt($.config.height,10);
		if(delta>0 && h>2000 || delta<0 && h<=Math.abs(delta)) return;
		h += delta;
		if(h<50) h=50;
		$.config.height=h+'px';
		$._editorObj().style.height= $.config.height;
		if('visual'==$.currentMode()){
			h-=4;//$._editorObj().offsetHeight-4;
			$._getDoc().body.style.minHeight=h+'px';
			if(isIE6) $._getDoc().body.style.height=h+'px';
		}
	};
	$._fixFull=function(){
		var d=$._doc();
		var e=$._containerDiv;
		e.style.zIndex='10000';
		e.style.width=(d.clientWidth-2) + 'px';
		e.style.top = $._docScrollTop()+'px';
		e.style.left = $._docScrollLeft()+'px';

		e=$._editorObj();
		var h= d.clientHeight-$._toolbarDiv.offsetHeight;
		if('visual'==$.currentMode()){
			e.style.height= h-2 + 'px';
			d = $._getDoc();
			if(d.body){
				h-=4;
				d.body.style.minHeight=h+'px';
				if(isIE6) d.body.style.height=h+'px';
			}
			e.style.width='';
		}else{
			e.style.width=(d.clientWidth-6)+'px';
			e.style.height= h-7 + 'px';
		}
	};
	$._doc=function(){
		return (document.compatMode != "CSS1Compat") ? document.body : document.documentElement;
	};
	$._docScrollTop=function(){
		var d=$._doc();
		return isIE || isOpera ? d.scrollTop : window.scrollY;
	};
	$._docScrollLeft=function(){
		var d=$._doc();
		return isIE || isOpera ? d.scrollLeft : window.scrollX;
	};
	$._button=function(name){
		var btns = $._children($._toolbarDiv,'LI');
		for(var i=btns.length-1;i>=0;i--){
			if(name==btns[i].getAttribute('name') ) {//	
				return btns[i];
			}
		}
		return null;
	};
	$.fullScreen=function(b){
		var e=$._containerDiv;
		if(b===undefined || null===b){
			b = (e.style.position!='absolute');
		}else{
			if(b == (ec.style.position=='absolute'))return;
		}
		var needFix= 'visual'==$.currentMode();
		if(needFix){
			var code=$.content(false);
		}
		if(b){
			document.body.parentNode.style.overflow = 'hidden';
			e.parentNode.removeChild(e);
			document.body.appendChild(e);
			if(needFix) $.setContent(code);
			e.style.position='absolute';
			e.style.top = '0px';
			$._fixFull();
			$.addListener(window,'resize',$._fixFull);

		}else{
			document.body.parentNode.style.overflow = 'auto';
			$.delListener(window,'resize',$._fixFull);
			e.style.position='';
			e.style.width=$.config.width;
			
			var o=$._editorObj();
			if('code'==$.currentMode())o.style.width=e.offsetWidth-6+'px';
			o.style.height=$.config.height;

			e.parentNode.removeChild(e);
			$.obj.parentNode.insertBefore(e,$.obj);
			if(needFix) $.setContent(code);
			e.scrollIntoView(false);
			if(needFix){//'visual'==$.currentMode()
				var d = $._getDoc();
				var h=o.offsetHeight-5;
				d.body.style.minHeight=h+'px';
				if(isIE6) d.body.style.height=h+'px';
			}
		}
		if(needFix){
			$._changed();
			$._hook();
		}
		$._hideContext();

		$._updateToolbar(!b,['IncHeight','DecHeight'], false);
		//更新全屏按钮图标
		var btn=$._button('FullScreen');
		if(btn){
			btn.style.backgroundPositionX = b ? -988 : -968;
		}
	};
	$.setContent=function(code){
		//code = ('code'==$.currentMode())? changeAsUbb(code):	changeAsHtml(code);
		if('code'==$.currentMode()){
			var o=$._editorObj();
			o.value=code;
			o.style.padding='2px';
			return;
		}
		if('visual'==$.currentMode()){
			if((isGecko || isOpera) && '<br>'==code.substring(0,4)) code=code.substr(4);//怪怪的Firefox
			var s='<!DOCTYPE html><html><head><style>\nbody{border:none;height:100%;margin:0;padding:2px;overflow:auto;';//
			if($.config.bgColor || $.config.textColor){
				if($.config.bgColor) s+='background-color:'+$.config.bgColor+';';
				if($.config.textColor) s+='color:'+$.config.textColor+';';
			}
			s +='}\nimg{cursor:default;}\n.splitPage{display:block;width:98%;border-top:#999 1px solid;border-bottom:#999 1px solid;background:#FFFFFF; color:#000000;font-weight:bold;text-align:center;margin:30px auto 5;padding-top:30px;clear:both;}\n.splitPage:before{content:"分页标题:";}</style>\n';
			if ($.config.css) {
				s += '<link href="' +$.config.css+ '" rel="stylesheet" type="text/css">\n';
			}
			s+='</head><body contenteditable="true" >'+ code+'</body></html>';
			var d = $._getDoc();
			d.open();
			d.write(s);
			d.close();
			var h=$._editorObj().offsetHeight-5;
			d.body.style.minHeight=h+'px';
			if(isIE6) d.body.style.height=h+'px';
			//d.designMode='On';
		}
	};
	$.setOpacity=function(e, opacity) {
		if (isIE) {
			e.style.filter = (opacity == 100) ? '' : 'gray() alpha(opacity=' + opacity + ')';
		} else {
			e.style.opacity = (opacity == 100) ? '' : opacity/100;
		}
    };
	$.inArray=function(e,arr){
		for(var i=arr.length-1;i>=0;i--) if(e==arr[i]) return true;
		return false;
	};
	$.content=function(){
		var m=$.currentMode();
		if('visual'===m){
			var code= $._getDoc().body.innerHTML;
			if((isGecko || isOpera) && '<br>'==code.substring(0,4)) code=code.substr(4);//怪怪的Firefox
		}else{
			code= $._editorObj().value;
		}
		return ($.config.formatHTML )? $.formatHTML(code) : code;
	};
	$._autoSave=function(){
		var e = $._editorObj();
		if (isIE ){
			$.addListener(e,'beforedeactivate',$.save);
		}else if('code'==$.currentMode()){ 
			$.addListener(e,'blur',$.save);
		}else{
			$.addListener(e.contentWindow,'blur',$.save);
		}
	};
	$.save=function(){
		$.obj.value=$.content();
	};
	$._intEdit=function(obj){
		if(obj.isIniEdit)return;
		obj.isIniEdit=true;
		obj.style.imeMode='disabled';
		obj.onkeypress=function(){if(45==event.keyCode){this.value = ('-'==this.value.charAt(0))? this.value.substr(1) : '-'+this.value; return false; }return event.keyCode>=48&&event.keyCode<=57;};
		obj.onpaste=function(){return !clipboardData.getData('text').match(/\D/);};
		obj.ondragenter=function(){return ! /\D/.test(event.dataTransfer.getData('text'));};
		obj.oldBlur=obj.onblur;
		obj.onblur=function(){if(''==this.value) return; this.value=parseInt(this.value,10);var max = this.getAttribute('max'); var min= this.getAttribute('min');if(max!=undefined && parseInt(this.value,10)>parseInt(max,10))this.value=parseInt(max,10);if(min!=undefined && parseInt(this.value,10)<parseInt(min,10))this.value=parseInt(min,10); if(this.oldBlur)this.oldBlur();};
	};
	$.drag=function(o){
		o.style.position='absolute';
		o.onmousedown=function(a){
			var x,y,obj,p=$._pos(this),scrollLeft = $._docScrollLeft(), scrollTop =$._docScrollTop();
			if(isIE){
				a=window.event;
				obj=a.srcElement;
				x=scrollLeft + a.clientX-p.x;
				y=scrollTop + a.clientY-p.y;
			}else{
				obj=a.target;
				x=a.pageX-p.x;
				y=a.pageY-p.y;
			}
			var n=obj.tagName;
			if(obj!=this && ( n=='INPUT' || n=='TEXTAREA'|| n=='BUTTON' || n=='BUTTON')) return;

			if(o.setCapture)
				o.setCapture();
			else if(window.captureEvents)
				window.captureEvents(Event.MOUSEMOVE|Event.MOUSEUP);

			document.onmousemove=function(a){
				if(isIE){
					a=window.event;
					a.pageX=scrollLeft + a.clientX;
					a.pageY=scrollTop + a.clientY;
				}
				var tx=a.pageX-x, ty=a.pageY-y;
				o.style.left=tx +'px';
				o.style.top=ty +'px';
			};

			document.onmouseup=function(){
				if(o.releaseCapture)
					o.releaseCapture();
				else if(window.captureEvents)
					window.captureEvents(Event.MOUSEMOVE|Event.MOUSEUP);
				document.onmousemove=null;
				document.onmouseup=null;
			};
		};
	};
	$.formatHTML=function(str){
		var remainInStr=str, outStr='';
		var ubbReg= new RegExp('\\s*(<(\\/?)([a-z]\\w*)[^>]*>)[\\r\\n]*','im');
		var indentChars=[];
		var wrapOutTags={'table':1,'tbody':1,'thead':1,'tfoot':1,'tr':1,'td':1,'p':1,'caption':1,'div':1,'object':1,'param':1,'embed':1,'dl':1,'dd':1,'dt':1,'ul':1,'ol':1,'li':1,'hr':1,'script':1};
		var indentTags={'table':1,'tbody':1,'thead':1,'tfoot':1,'tr':1,'object':1,'dl':1,'ul':1,'ol':1,'div':1,'script':1};
		var embedTags={'a':1,'u':1,'i':1,'b':1,'strong':1,'em':1,'font':1,'span':1,'img':1,'input':1,'h1':1,'h2':1,'h3':1,'h4':1,'h5':1,'h6':1};//保持不变的标签
		while( null != (result = ubbReg.exec(remainInStr))){
			var text = remainInStr.substr(0, result.index);
			var tagExt=	result[0];
			var tagFull=result[1];
			var isEndTag = '/'===result[2];
			var tagName=result[3].toLowerCase();

			remainInStr = remainInStr.substr(result.index + tagExt.length);
			outStr += text;
			if(isEndTag){
				if(indentTags[tagName]) indentChars.pop();
				if(embedTags[tagName]) outStr += tagExt; 
				else if(indentTags[tagName]) outStr +="\n"+indentChars.join('')+tagFull;
				else outStr += tagFull ;

				if(wrapOutTags[tagName]) outStr+="\n"; 
			}else{
				if(wrapOutTags[tagName]) outStr+="\n"; 
				if(embedTags[tagName]) outStr += tagExt; 
				else if(indentTags[tagName]) outStr += indentChars.join('')+tagFull+"\n";
				else outStr += indentChars.join('')+tagFull;
				if('hr'===tagName || 'br'===tagName) outStr+="\n"; 
				if(indentTags[tagName]) indentChars.push('  ');
			}
		}
		outStr += remainInStr;
		outStr = outStr.replace(/\n+/g, "\n");
		return outStr;
	};
	//---------
	if(!isIE6){
		$.init();
	}else{
		var _topTableNode=function(node){
			var  reault=null;
			while(node){
				 if(node.tagName=='TABLE'){
					reault=node;
				 }
				 node = node.parentNode;
			}
			return reault;
		}
		if(_topTableNode($.find(objId)) == _topTableNode(document.scripts(document.scripts.length-1))){
			window.setTimeout($.init,8);
		}else{
			$.init();
		}
	}
}
tqEditor.version='1.3.0 rc3'; //编辑器版本
tqEditor.url='./';//编辑器相关资源网址
if(tqEditor.url==='./'){
	if(isGecko) document.scripts =TQE._tags(document,'SCRIPT');
	var tqJSUrl = document.scripts(document.scripts.length-1).src;
	tqEditor.url = tqJSUrl.substring(0,tqJSUrl.toLowerCase().indexOf('tqeditor.'));
	document.write('<link href="'+tqEditor.url+'TQEditor.css" rel="stylesheet" type="text/css" />');
}
tqEditor.loadSkin=function(skin){
	var e = document.getElementById('TQEditorSkinCSS');
	if(e){
		e.href=tqEditor.url+'TQEditor.'+skin+'.css';
		return;
	}
	e=document.createElement('LINK');
	e.id='TQEditorSkinCSS';
	e.href=tqEditor.url+'TQEditor.'+skin+'.css';
	e.rel='stylesheet';
	e.type='text/css';
	document.documentElement.firstChild.appendChild(e);
};